      subroutine logderiv(n,irc,nmx,h,nz,r,wf,twf,cwf,rv,v0,v0p,rveff, &
        tv0,tv0p,mxo,otp,odphi,otphi,mxb,mxnl,hij,qij,lmax,nos,nop,nod, &
        nof,nog,am,bm,mxwk,wk,nbase,iscr,iiirc)
!  program to calculate logerivatives of paw wavefunctions
!   and to compare them with all electron wavefunctions
!  optionally, wavefunctions are written to a file
      implicit real*8 (a-h,o-z)
      dimension r(nmx),rv(nmx)
      dimension rveff(nmx),wk(nmx,mxwk),wf(nmx),twf(nmx)
      dimension cwf(nmx),odphi(nmx,mxo),otp(nmx,mxo),otphi(nmx,mxo)
      dimension am(mxb,mxb),bm(mxb)
      dimension hij(mxb,mxb,mxnl),qij(mxb,mxb,mxnl)
      character*4 flnm
      character*1 :: answer
!
!   calculate logderivatives at irc
!
      write(6,*) 'calculating log derivatives at irc',r(irc)
       ne=200
       e0=-5
        de=0.05
        ke=100
! uncomment is wish to use options
!      write(6,*)' Default values -- ne(200) e0(-5) de(0.05)   ke(100) '
!      write(6,*) '  Enter y and then new ne e0 de ke if you prefer'
!      read(5,*) answer
!      if (answer.eq.'y') read(5,*) ne,e0,de,ke
      !write(6,*) 'entering logderiv with nbase = ',nbase
      !call flush(6)
!
      mbase=nbase

      do l=0,lmax

       istart=1
       if (l.gt.0) then
       do il=0,l-1
       if (il.eq.0) many=nos
       if (il.eq.1) many=nop
       if (il.eq.2) many=nod
       if (il.eq.3) many=nof
       if (il.eq.4) many=nog
       istart=istart+many
       enddo
       endif
       if (l.eq.0) many=nos
       if (l.eq.1) many=nop
       if (l.eq.2) many=nod
       if (l.eq.3) many=nof
       if (l.eq.4) many=nog
       iscr=iscr+1
       call mkname(l,flnm)
       open(iscr,file='logderiv.'//flnm,form='formatted')
        if (ne.gt.1) then
       do ie=1,ne
       energy=e0+de*(ie-1)
       call unboundsch(iiirc,energy,nmx,wf,l,nz,rv,h,v0,v0p,node,       &
        wk,wk(1,2))
       if (many+3.gt.mxwk) then
        write(6,*) 'mxwk too small',mxwk,many+3
        write(6,*) 'terminating in genproj'
        stop
        endif
       call unboundsep(iiirc,energy,twf,l,rveff,h,tv0,tv0p,             &
        otp(1,istart),nmx,hij(1,1,l+1),qij(1,1,l+1),mxb,many,           &
        am,bm,wk,wk(1,many+1),wk(1,many+2),wk(1,many+3))
!
       dwdr=(wf(irc+1)-wf(irc-1))/(2*h*wf(irc))
        call smoothtoae(iiirc,h,twf,cwf,nmx,many,otp(1,istart)          &
           ,odphi(1,istart))
       dcwdr=(cwf(irc+1)-cwf(irc-1))/(2*h*cwf(irc))
         call alanfac(iiirc,h,twf,nmx,many,otp(1,istart)                &
           ,otphi(1,istart),diff)
!      write(6,*) 'energy lder tlder = ',energy,dwdr,dcwdr,diff
       write(iscr,680) energy,dwdr,dcwdr,diff
  680  format(1p5e12.4)
       if (ie.eq.ke) then
       mbase=mbase+1
      call mkname(mbase,flnm)
      open(unit=iscr+1,file='wfn'//flnm,form='formatted')
      write(iscr+1,*) 'l=',l,'energy=',energy
!
! form converted wavefunction and rescale exact wavefunction
!
!       call smoothtoae(iiirc,h,twf,cwf,nmx,many,otp(1,istart)
!    x     ,odphi(1,istart))
!
      scale=cwf(iiirc)/wf(iiirc)
      do i=1,iiirc
      write(iscr+1,680) r(i),twf(i),cwf(i),wf(i)*scale
      enddo
      close(iscr+1)
      endif
      enddo
      endif
      enddo
      return
       end
